--  CREATE DATABASE [SQLsat_xmlBattle];
use SQLsat_xmlBattle
GO

----  preparation
IF OBJECT_ID (N'CarManufacturer_xml', N'U') IS NOT NULL 
   DROP TABLE dbo.CarManufacturer_xml;


CREATE TABLE  dbo.CarManufacturer_xml(
	          ID        int IDENTITY(1,1) NOT NULL
	        , [key]     nvarchar(50)          NULL
			, xmlValue  xml                   NULL
,  CONSTRAINT PK_CarManufacturer_xml PRIMARY KEY CLUSTERED 
            ( ID        ASC )
); 
GO

----  fill in sampledata
INSERT INTO dbo.CarManufacturer_xml
          ( [key]  , xmlValue )
VALUES    ( 'Key01', '<Customer CustomerID="1021"><!-- info 1021 customer since 2010--><CompanyName>Alfa Romeo</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key02', '<Customer CustomerID="1022"><!-- info 1022 customer since 2010--><CompanyName>Aston Martin</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key03', '<Customer CustomerID="1023"><!-- info 1023 customer since 2010--><CompanyName>Audi</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key04', '<Customer CustomerID="1024"><!-- info 1024 customer since 2010--><CompanyName>Bentley</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key05', '<Customer CustomerID="1025"><!-- info 1025 customer since 2010--><CompanyName>BMW</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key06', '<Customer CustomerID="1026"><!-- info 1026 customer since 2010--><CompanyName>Bugatti</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key07', '<Customer CustomerID="1027"><!-- info 1027 customer since 2010--><CompanyName>Chevrolet</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key08', '<Customer CustomerID="1028"><!-- info 1028 customer since 2010--><CompanyName>Chrysler</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key09', '<Customer CustomerID="1029"><!-- info 1029 customer since 2010--><CompanyName>Citron</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key10', '<Customer CustomerID="1030"><!-- info 1030 customer since 2010--><CompanyName>Dacia</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key11', '<Customer CustomerID="1031"><!-- info 1031 customer since 2010--><CompanyName>Daihatsu</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key12', '<Customer CustomerID="1032"><!-- info 1032 customer since 2010--><CompanyName>Ferrari</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key13', '<Customer CustomerID="1033"><!-- info 1033 customer since 2010--><CompanyName>Fiat</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key14', '<Customer CustomerID="1034"><!-- info 1034 customer since 2010--><CompanyName>Ford</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key15', '<Customer CustomerID="1035"><!-- info 1035 customer since 2010--><CompanyName>Honda</CompanyName><CustomerSince>2010</CustomerSince></Customer>' )
		, ( 'Key16', '<Customer CustomerID="1036"><!-- info 1036 customer since 2012--><CompanyName>Hyundai</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key17', '<Customer CustomerID="1037"><!-- info 1037 customer since 2012--><CompanyName>Infiniti</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key18', '<Customer CustomerID="1038"><!-- info 1038 customer since 2012--><CompanyName>Jaguar</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key19', '<Customer CustomerID="1039"><!-- info 1039 customer since 2012--><CompanyName>Kia</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key20', '<Customer CustomerID="1040"><!-- info 1040 customer since 2012--><CompanyName>Lada</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key21', '<Customer CustomerID="1041"><!-- info 1041 customer since 2012--><CompanyName>Lamborghini</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key22', '<Customer CustomerID="1042"><!-- info 1042 customer since 2012--><CompanyName>Lancia</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key23', '<Customer CustomerID="1043"><!-- info 1043 customer since 2012--><CompanyName>Land Rover</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key24', '<Customer CustomerID="1044"><!-- info 1044 customer since 2012--><CompanyName>Lexus</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key25', '<Customer CustomerID="1045"><!-- info 1045 customer since 2012--><CompanyName>Lotus</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key26', '<Customer CustomerID="1046"><!-- info 1046 customer since 2012--><CompanyName>Maserati</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key27', '<Customer CustomerID="1047"><!-- info 1047 customer since 2012--><CompanyName>Maybach</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key28', '<Customer CustomerID="1048"><!-- info 1048 customer since 2012--><CompanyName>Mazda</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key29', '<Customer CustomerID="1049"><!-- info 1049 customer since 2012--><CompanyName>Mercedes Benz</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key30', '<Customer CustomerID="1050"><!-- info 1050 customer since 2012--><CompanyName>Mini</CompanyName><CustomerSince>2012</CustomerSince></Customer>' )
		, ( 'Key31', '<Customer CustomerID="1051"><!-- info 1051 customer since 2014--><CompanyName>Mitsubishi</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key32', '<Customer CustomerID="1052"><!-- info 1052 customer since 2014--><CompanyName>Nissan</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key33', '<Customer CustomerID="1053"><!-- info 1053 customer since 2014--><CompanyName>Opel</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key34', '<Customer CustomerID="1054"><!-- info 1054 customer since 2014--><CompanyName>Peugeot</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key35', '<Customer CustomerID="1055"><!-- info 1055 customer since 2014--><CompanyName>Porsche</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key36', '<Customer CustomerID="1056"><!-- info 1056 customer since 2014--><CompanyName>Renault</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key37', '<Customer CustomerID="1057"><!-- info 1057 customer since 2014--><CompanyName>Rolls-Royce</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key38', '<Customer CustomerID="1058"><!-- info 1058 customer since 2014--><CompanyName>Saab</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key39', '<Customer CustomerID="1059"><!-- info 1059 customer since 2014--><CompanyName>Seat</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key40', '<Customer CustomerID="1060"><!-- info 1060 customer since 2014--><CompanyName>Skoda</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key41', '<Customer CustomerID="1061"><!-- info 1061 customer since 2014--><CompanyName>Smart</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key42', '<Customer CustomerID="1062"><!-- info 1062 customer since 2014--><CompanyName>Subaru</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key43', '<Customer CustomerID="1063"><!-- info 1063 customer since 2014--><CompanyName>Suzuki</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key44', '<Customer CustomerID="1064"><!-- info 1064 customer since 2014--><CompanyName>Tata</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key45', '<Customer CustomerID="1065"><!-- info 1065 customer since 2014--><CompanyName>Toyota</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key46', '<Customer CustomerID="1066"><!-- info 1066 customer since 2014--><CompanyName>Volkswagen</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )
		, ( 'Key47', '<Customer CustomerID="1067"><!-- info 1067 customer since 2014--><CompanyName>Volvo</CompanyName><CustomerSince>2014</CustomerSince></Customer>' )

----  check
select * from dbo.CarManufacturer_xml

----  1st Query
SELECT [key], xmlValue.query('*') as Complete_Sequence
FROM   dbo.CarManufacturer_xml

----  2nd Query
SELECT [key], xmlValue.query('data(*)') as Complete_Data
FROM   dbo.CarManufacturer_xml 

----  3rd Query  /node()   &   /comment()
SELECT [key]
     , xmlValue.query('/Customer/CompanyName/node()') as CompanyName
	 , xmlValue.query('/Customer/comment()')
FROM   dbo.CarManufacturer_xml

SET Statistics TIME ON
SET Statistics IO   ON

--  Demo: ( Ctrl + L )  estimated Execution Plan
-------
-- https://msdn.microsoft.com/en-us/library/ms191497.aspx
-- XML Indexes (SQL Server)

CREATE PRIMARY XML INDEX IX_primaryXml 
ON  dbo.CarManufacturer_xml  ( xmlValue )


CREATE XML INDEX IX_Xml_PATH 
ON  dbo.CarManufacturer_xml  ( xmlValue )
USING XML INDEX  IX_primaryXml 
FOR PATH;
GO
CREATE XML INDEX IX_Xml_VALUE
ON  dbo.CarManufacturer_xml  ( xmlValue )
USING XML INDEX  IX_primaryXml 
FOR VALUE;
GO

------------------
------------------