use SQLsat_xmlBattle
GO

IF OBJECT_ID (N'randConsumtionData', N'P') IS NOT NULL 
   DROP PROC dbo.randConsumtionData;
GO

CREATE PROC randConsumtionData
            @xmlResult  xml  OUTPUT
AS
BEGIN

DECLARE @cust uniqueidentifier = NewID()

DECLARE @temp TABLE (
          CustID     uniqueidentifier
        , consDay    int
        , consValue  int
		)
;


WITH ListNumbers
AS
(
	select n = 1
	union  all
	select n + CAST(RAND() * 10 + 1 as INT)
	from   ListNumbers
	where  n + CAST(RAND() * 10 + 1 as INT) <= 30
)
INSERT INTO @temp
SELECT @cust, n as 'consumptionDay', CAST(RAND() * 10 + 1 as INT) as 'consumtionValue' 
FROM   ListNumbers
;

SET @xmlResult = (	SELECT Customer.CustID       as 'CustID'
						 , Consumtion.consDay    as 'consumptionDay'
						 , Consumtion.consValue  as 'consumtionValue'
					FROM   ( select distinct CustID from @temp ) Customer
					JOIN   ( select * from @temp ) Consumtion
					ON     Customer.CustID = Consumtion.CustID
					FOR    XML AUTO, ELEMENTS, ROOT('CustomerData')
                  )

END  -- end Proc


----------------
----------------