-- XML-Schema  -- booksample  70-433 page 275ff.
USE SQLsat_xmlBattle
GO

--DROP XML SCHEMA COLLECTION  dbo.bookSchemaCollection 
CREATE XML SCHEMA COLLECTION  dbo.bookSchemaCollection
AS
N'<?xml version="1.0"?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
    targetNamespace="http://www.test-fabrik.de/BooksSchema"
	xmlns="http://www.test-fabrik.de/BooksSchema"
	elementFormDefault="qualified">
	<xs:element name="Book">
		<xs:complexType>
			<xs:attribute name="Title" type="xs:string"/>
			<xs:attribute name="Price" type="xs:decimal"/>
		</xs:complexType>
	</xs:element>
</xs:schema>';
GO


IF OBJECT_ID (N'Books_xml', N'U') IS NOT NULL 
   DROP TABLE dbo.Books_xml;

CREATE TABLE  dbo.Books_xml(
              ID        int Identity(1,1)
            , [key]     nvarchar(50)
			, xmlRaw    xml
			, xmlValue  xml(DOCUMENT bookSchemaCollection)
			);

INSERT dbo.Books_xml
       ( [key] , xmlRaw )
VALUES ( 'key01', '<Book xmlns="http://www.test-fabrik.de/BooksSchema"
                         Title="the booksample1" 
					     Price="100" />')

INSERT dbo.Books_xml
       ( [key] , xmlValue )
VALUES ( 'key02', '<Book xmlns="http://www.test-fabrik.de/BooksSchema"
                         Title="the booksample2" 
						 Price="49.90" />')

--------------
-- !! decimal ,
INSERT dbo.Books_xml
       ( [key] , xmlValue )
VALUES ( 'key03', '<Book xmlns="http://www.test-fabrik.de/BooksSchema"
                         Title="! v ! Book" 
						 Price="49,90" />')

--Msg 6926, Level 16, State 1, Line 40
--XML Validation: Invalid simple type value: '49,90'. Location: /*:Book[1]/@*:Price
-----------------

-- sample for single-Query
WITH XMLNAMESPACES( DEFAULT 'http://www.test-fabrik.de/BooksSchema'
                  , 'http://www.w3.org/2001/XMLSchema' as xs)
SELECT Buchtitel  as '@Title'
	 , Preis      as '@Price'
FROM   Verlag.dbo.Buch
WHERE  ID = 1 --@booknumber
FOR    XML PATH('Book'), TYPE

----------
----------
DECLARE @xmlValue  xml 
      , @keyValue  nvarchar(10);

DECLARE @ii        int
      , @max       int;

DECLARE @tmpTab    Table (singleXML xml);
DECLARE @sqlCmd    nvarchar(4000);

SET @ii  = ( select min(ID) from dbo.Buch );
SET @max = ( select max(ID) from dbo.Buch );
			
WHILE (@ii <= @max)
BEGIN	
	SET @sqlCmd = ' WITH XMLNAMESPACES( DEFAULT ''http://www.test-fabrik.de/BooksSchema''
									  , ''http://www.w3.org/2001/XMLSchema'' as xs)
					SELECT Buchtitel  as ''@Title''
						 , Preis      as ''@Price''
					FROM   Verlag.dbo.Buch
					WHERE  ID = ' + CAST(@ii as nvarchar(4)) --@booknumber
				+ '	FOR    XML PATH(''Book''), TYPE' 

    INSERT INTO @tmpTab
	EXEC( @sqlCmd )

    SET @keyValue = 'key' + Right('0000' + CAST(@ii as nvarchar(4)), 4 );	
	SET @xmlValue = ( select TOP(1) singleXML from @tmpTab)
						 				 
	INSERT dbo.Books_xml
		   ( [key]     ,  xmlValue )
	VALUES ( @keyValue , @xmlValue )

	----
	DELETE FROM @tmpTab
	SET @ii = @ii + 1

END  -- end WHILE
-----------------

SELECT *
FROM   dbo.Books_xml
--------------------
--------------------