-- Sample FOR XML Queries
-- FOR XML mode queries can be nested to produce hierarchies

USE AdventureWorks2008R2
GO

SELECT c.CustomerID     as '@ID'             -- as "ID"  also possible
     , c.AccountNumber  as '@AccountNumber'
	 , (
		SELECT sh.SalesOrderID   as '@ID'
		     , sh.OrderDate      as '@OrderDate'
			 , sh.ShipDate       as '@ShipDate'
			 , (
				 SELECT sd.ProductID   as '@ProductID'
				      , sd.OrderQty    as '@OrderQty'
					  , sd.UnitPrice   as '@UnitPrice'
				 FROM   Sales.SalesOrderDetail sd
				 WHERE  sd.SalesOrderID = sh.SalesOrderID
				 FOR    XML PATH('OrderDetail'), TYPE
			   )
		FROM   Sales.SalesOrderHeader sh
		WHERE  sh.CustomerID = c.CustomerID
		FOR    XML PATH('Order'), TYPE
	   )
FROM   Sales.Customer c
WHERE  c.CustomerID = 11828
FOR    XML PATH('Customer')